"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Credentials = void 0;
exports.buildFromAuthorization = buildFromAuthorization;
class Credentials {
    username;
    password;
    constructor(username, password) {
        this.username = username;
        this.password = password;
    }
}
exports.Credentials = Credentials;
const BASIC_AUTH_REG = /^ *(?:[Bb][Aa][Ss][Ii][Cc]) +([A-Za-z0-9._~+/-]+=*) *$/;
const USER_PASSWORD_REG = /^([^:]*):(.*)$/;
function buildFromAuthorization(str) {
    if (typeof str !== 'string') {
        return null;
    }
    const basicAuthMatchResult = BASIC_AUTH_REG.exec(str);
    if (!basicAuthMatchResult) {
        return null;
    }
    const userPasswordMatchResult = USER_PASSWORD_REG.exec(Buffer.from(basicAuthMatchResult[1], 'base64').toString());
    if (!userPasswordMatchResult) {
        return null;
    }
    return new Credentials(userPasswordMatchResult[1], userPasswordMatchResult[2]);
}
//# sourceMappingURL=credentials.js.map